#!/bin/sh

SESSION_FILE="/var/spool/tvctrl/session/check_session"
SESSION_LIST="/var/spool/tvctrl/session/session_list"
DATE=`/bin/date +%Y%m%d`
TIME=`/bin/date +%H:%M:%S`
LOG_FILE="/var/spool/tvctrl/log/check_$DATE.log"

PID=`/bin/ps -ef | /bin/grep producer | /bin/grep -v grep | /bin/grep localhost | /usr/bin/awk '{ print $2; }'`

if [ "$PID" == "" ]; then
  echo "$TIME no pid for producer" >> $LOG_FILE
  if [ -f $SESSION_FILE ]; then
    echo "$TIME delete $SESSION_FILE" >> $LOG_FILE
    /bin/rm -f $SESSION_FILE
  fi
  if [ -f $SESSION_LIST ]; then
    echo "$TIME delete $SESSION_LIST" >> $LOG_FILE
    /bin/rm -f $SESSION_LIST
  fi
  exit;
fi

CNT=`/bin/netstat -na | /bin/grep ":554 " | /bin/grep -v 127.0.0.1:554 | /bin/grep -v 0.0.0.0:* | wc -l`

if [ "$CNT" == "0" ]; then
  echo "$TIME no any session now" >> $LOG_FILE
  if [ -f $SESSION_LIST ]; then
    echo "$TIME delete $SESSION_LIST" >> $LOG_FILE
    /bin/rm -f $SESSION_LIST
  fi
  if [ -f $SESSION_FILE ]; then
    echo "$TIME $SESSION_FILE exists, kill procedure $PID and delete the file" >> $LOG_FILE
    /bin/kill -15 $PID
    /bin/rm -f $SESSION_FILE
    exit
  fi
  echo "$TIME create $SESSION_FILE" >> $LOG_FILE
  /bin/touch $SESSION_FILE
  exit
fi

echo "$TIME $CNT session exists" >> $LOG_FILE
if [ -f $SESSION_FILE ]; then
  echo "$TIME delete $SESSION_FILE" >> $LOG_FILE
  /bin/rm -f $SESSION_FILE
fi

if [ ! -f $SESSION_LIST ]; then
  echo "$TIME create $SESSION_LIST" >> $LOG_FILE
  /bin/touch $SESSION_LIST
  echo "$TIME ============= session =============" >> $LOG_FILE
  /bin/netstat -na | /bin/grep ":554 " | /bin/grep -v 127.0.0.1:554 | /bin/grep -v 0.0.0.0:* >> $LOG_FILE
  echo "$TIME ============= session =============" >> $LOG_FILE
fi

exit
