#!/bin/sh

if [ "$1" == "" ]; then
  echo "Syntax: $0 output channel length [width [height]]"
  exit
fi
if [ "$2" == "" ]; then
  echo "Syntax: $0 output channel length [width [height]]"
  exit
fi
if [ "$3" == "" ]; then
  echo "Syntax: $0 output channel length [width [height]]"
  exit
fi
if [ "$4" != "" ]; then
  WIDTH="$4"
else
  WIDTH="480"
fi
if [ "$5" != "" ]; then
  HEIGHT="$5"
else
  HEIGHT="360"
fi

OUTPUT="$1"
CHANNEL="$2"
LENGTH="$3"
VIDEO_DEV="norm=ntsc:chanlist=us-cable:device=/dev/video0:input=0"
AUDIO_DEV="alsa:adevice=hw.0,0:audiorate=32000"
SCALE="width=$WIDTH:height=$HEIGHT"

PASSLOG="/tmp/mencoder-pass.log"

MPEG4_CODEC="-ovc lavc -lavcopts vcodec=mpeg4:mbd=2:trell"
H264_CODEC="-ovc x264 -x264encopts subq=4:bframes=2:b_pyramid:weight_b:pass=1:bitrate=1000:threads=2"
VIDEO_CODEC=$H264_CODEC

MP3_CODEC="-oac mp3lame -lameopts cbr:br=128"
AUDIO_CODEC=$MP3_CODEC

/usr/bin/v4lctl setchannel $CHANNEL
/usr/bin/amixer sset Line Capture cap > /dev/null

rm -f $OUTPUT

/usr/bin/mencoder tv://$CHANNEL \
 -tv driver=v4l2:$SCALE:$VIDEO_DEV:$AUDIO_DEV \
 -passlogfile $PASSLOG \
 $VIDEO_CODEC \
 $AUDIO_CODEC \
 -endpos $LENGTH \
 -o $OUTPUT > /dev/null 2> /dev/null

rm -f $PASSLOG
