<?php
require_once('config.php');

if (!isset($_GET['fileid'])) {
    header('HTTP/1.0 404 Not Found');
    exit;
}
$fileid = $_GET['fileid'];
$file = getFileWithID($fileid);
if ($file === false || $file === '' || !is_file($file)) {
    header('HTTP/1.0 404 Not Found');
    exit;
}
dl_file_resumable($file);
exit;

function dl_file_resumable($file)
{
    if (!is_file($file)) {
        header('HTTP/1.0 404 Not Found');
        exit;
    }

    $size = filesize($file);
    $filename = basename($file);

    //workaround for IE filename bug with multiple periods / multiple dots in filename
    //that adds square brackets to filename - eg. setup.abc.exe becomes setup[1].abc.exe
    if (strstr($_SERVER['HTTP_USER_AGENT'], 'MSIE'))
        $filename = preg_replace('/\./', '%2e', $filename, substr_count($filename, '.') - 1);

    //check if http_range is sent by browser (or download manager)
    if (isset($_SERVER['HTTP_RANGE'])) {
        list($size_unit, $range_orig) = explode('=', $_SERVER['HTTP_RANGE'], 2);
        if ($size_unit == 'bytes') {
            //multiple ranges could be specified at the same time, but for simplicity only serve the first range
            //http://tools.ietf.org/id/draft-ietf-http-range-retrieval-00.txt
            list($range, $extra_ranges) = explode(',', $range_orig, 2);
        }
        else
            $range = '';
    }
    else
        $range = '';

    //figure out download piece from range (if set)
    list($seek_start, $seek_end) = explode('-', $range, 2);

    //set start and end based on range (if set), else set defaults
    //also check for invalid ranges.
    $seek_end = (empty($seek_end)) ? ($size - 1) : min(abs(intval($seek_end)),($size - 1));
    $seek_start = (empty($seek_start) || $seek_end < abs(intval($seek_start))) ? 0 : max(abs(intval($seek_start)),0);

    //Only send partial content header if downloading a piece of the file (IE workaround)
    if ($seek_start > 0 || $seek_end < ($size - 1))
    {
        header('HTTP/1.1 206 Partial Content');
    }

    header('Accept-Ranges: bytes');
    header('Content-Range: bytes '.$seek_start.'-'.$seek_end.'/'.$size);

    header('Content-Type: video/x-msvideo');
    header('Content-Disposition: attachment; filename="'.$filename.'"');
    header('Content-Length: '.($seek_end - $seek_start + 1));

    $fp = fopen($file, 'rb');
    fseek($fp, $seek_start);
    set_time_limit(0);
    fpassthru($fp);

    exit;
}

function getFileWithID($fileid)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return '';
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return '';
    }
    fputs($fp, "REC_GET_FILE $fileid\n");
    $filename = '';
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    if ($buf[0] != '+') return '';
    list(/* + */, $file) = explode(' ', $buf);
    $fname = base64_decode(trim($file));
    return $fname;
}

?>
