<?php
@session_start();

require_once('config.php');
require_once('smarty/libs/Smarty.class.php');
require_once('lang.php');

$smarty = new Smarty();
$smarty->template_dir = '';
$smarty->compile_dir = 'templates_c/';
$smarty->config_dir = '';
$smarty->cache_dir = '';
$smarty->left_delimiter = '<{';
$smarty->right_delimiter = '}>';

unset($username);
unset($password);
if (isset($_SESSION['username']))
    $username = $_SESSION['username'];
else if (isset($_POST['sid'])) {
    $buf = checkSession($_POST['sid']);
    if ($buf !== false && $buf[0] === '+') {
        list(/* + */, $name, $allow_rec) = explode(' ', $buf);
        $name = trim($name);
        if ($name !== '') {
            $username = $name;
            $_SESSION['username'] = $username;
            $_SESSION['sid'] = $_POST['sid'];
            $_SESSION['allow_rec'] = $allow_rec;
        }
    }
}

if (!isset($username) || empty($username)) {
    $username = isset($_POST['username']) ? $_POST['username'] : '';
    $password = isset($_POST['password']) ? $_POST['password'] : '';
    $errmsg = '';

    if (isset($username) && !empty($username)) {
        $errmsg = $lang['ERROR_LOGIN'];
        if (isset($password) && !empty($password)) {
            // check login
            $result = checkAuth($username, $password);
            if ($result !== false && is_array($result)) {
                $sid = trim($result['sid']);
                $allow_rec = trim($result['allow_rec']);
                $buf = getServerStatus($sid);
                if ($buf === false || $buf[0] !== '+') {
                    unset($_SESSION['sid']);
                    unset($_SESSION['username']);
                    $errmsg = $lang['LOGIN_AGAIN'];
                    require_once('login.php');
                    ShowLogin($username, $errmsg);
                    exit;
                }
                $_SESSION['server_data'] = explode(' ', $buf);
                unset($_SESSION['last_recorder_size']);
                // show main page
                $_SESSION['username'] = $username;
                $_SESSION['sid'] = $sid;
                $_SESSION['allow_rec'] = $allow_rec;
                require_once('menu.php');
                ShowMenu();
                exit;
            }
        }
    }
    require_once('login.php');
    ShowLogin($username, $errmsg);
    exit;
}


if (isset($_POST['logout'])) {
    sendLogout($_SESSION['sid']);
    session_unset();
    session_destroy();
    require_once('login.php');
    ShowLogin('', '');
    exit;
}

if (isset($_POST['start']))
    sendStart($_SESSION['sid'], $_POST['bandwidth'], $_POST['size']);
else if (isset($_POST['stop']))
    sendStop($_SESSION['sid']);
else if (isset($_POST['setchannel']))
    sendChannel($_SESSION['sid'], $_POST['channel_val']);
else if (isset($_POST['setvolume']))
    sendVolume($_SESSION['sid'], $_POST['volume_val']);
else if (isset($_POST['recorder'])) {
    require_once('recorder.php');
    ShowRecMenu();
    exit;
}
else if (isset($_POST['recorder_kill'])) {
    sendStopRecorder($_SESSION['sid']);
}
else if (isset($_POST['recorder_add'])) {
    $result = sendAddRecorder($_SESSION['sid'], $_POST['rec_start_time'], $_POST['rec_end_time'], $_POST['rec_channel'], $_POST['rec_size']);
    require_once('recorder.php');
    if ($result[0] !== '+')
        ShowRecMenu($result, $_POST['rec_start_time'], $_POST['rec_end_time'], $_POST['rec_channel'], $_POST['rec_size']);
    else {
        $_SESSION['last_recorder_size'] = $_POST['rec_size'];
        ShowRecMenu($result);
    }
    exit;
}
else if (isset($_POST['mainmenu'])) {
    // do nothing for this
}
else {
    foreach ($_POST as $key => $value) {
        if (strncmp($key, 'setchannel_', 11) == 0) {
            $ch = base64_decode(substr($key, 11));
            sendChannel($_SESSION['sid'], $ch);
            break;
        }
        if (strncmp($key, 'rec_delete_', 11) == 0) {
            $fname = base64_decode(substr($key, 11));
            $result = sendDelRecorder($_SESSION['sid'], $fname);
            require_once('recorder.php');
            ShowRecMenu($result);
            exit;
        }
        if (strncmp($key, 'rec_file_delete_', 16) == 0) {
            $fname = base64_decode(substr($key, 16));
            $result = sendDelRecorderFile($_SESSION['sid'], $fname);
            require_once('recorder.php');
            ShowRecMenu($result);
            exit;
        }
    }
}

$buf = getServerStatus($_SESSION['sid']);
if ($buf == false || $buf[0] === '!') {
    $errmsg = $lang['LOGIN_AGAIN'];
    session_unset();
    session_destroy();
    require_once('login.php');
    ShowLogin($username, $errmsg);
    exit;
}
$_SESSION['server_data'] = explode(' ', $buf);
unset($_SESSION['last_recorder_size']);
require_once('menu.php');
ShowMenu();
exit;

function checkSession($sid)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    fputs($fp, "SESSION $sid\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function getServerStatus($sid)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    fputs($fp, "STATUS $sid\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function sendLogout($sid)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    fputs($fp, "LOGOUT $sid\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function sendStart($sid, $bandwidth, $size)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    fputs($fp, "START $sid $bandwidth $size\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function sendStop($sid)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    fputs($fp, "STOP $sid\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function sendChannel($sid, $channel)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    $ch = base64_encode($channel);
    fputs($fp, "CHANNEL $sid $ch\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function sendVolume($sid, $volume)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    $vol = base64_encode($volume);
    fputs($fp, "VOLUME $sid $vol\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function sendAddRecorder($sid, $start_time, $end_time, $channel, $size)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    $stime = base64_encode($start_time);
    $etime = base64_encode($end_time);
    $ch = base64_encode($channel);
    // size already encoded
    fputs($fp, "REC_ADD $sid $stime $etime $ch $size\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function sendDelRecorder($sid, $fname)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    $file = base64_encode($fname);
    fputs($fp, "REC_DEL $sid $file\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function sendDelRecorderFile($sid, $fname)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    $file = base64_encode($fname);
    fputs($fp, "REC_DEL_FILE $sid $file\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function sendStopRecorder($sid)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    $file = base64_encode($fname);
    fputs($fp, "REC_STOP $sid\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function checkAuth($username, $password)
{
    global $server, $port;

    if ($username == '') return false;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = fgets($fp);
    if ($buf[0] != '+') {
        fclose($fp);
        return false;
    }
    fputs($fp, "LOGIN ".base64_encode($username)." ".base64_encode($password)."\n");
    $buf = fgets($fp);
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    if ($buf[0] != '+')
        return false;
    if ($buf[0] != '+')
        return false;
    list(/* + */, $sid, $allow_rec) = explode(' ', $buf);
    return array('sid' => $sid, 'allow_rec' => $allow_rec);
}

?>
