<?php

if (!defined('IN_MYTV')) {
    $uri = $_SERVER['REQUEST_URI'];
    $url = dirname($uri);
    header('Location: '.$url);
    exit;
}

function loadRecorderData($cur_data)
{
    $fp = fopen('recordersize.dat', 'rt');
    if (!$fp) return false;
    $aData = array();
    while (!feof($fp)) {
        $buf = trim(fgets($fp));
        list($value, $name) = explode(':', $buf, 2);
        if ($cur_data == $value)
            $select = ' selected';
        else
            $select = '';
        $aData[] = array('value' => base64_encode($value),
                         'name' => htmlspecialchars($name),
                         'selected' => $select);
    }
    fclose($fp);
    return $aData;
}

function ShowRecMenu($msg = '', $start_time = '', $end_time = '', $channel = '', $recorder_size = '')
{
    global $smarty, $lang;

    $username = $_SESSION['username'];
    $sid = $_SESSION['sid'];

    if ($recorder_size === '') {
        if (isset($_SESSION['last_recorder_size']))
            $size = base64_decode($_SESSION['last_recorder_size']);
        else {
            $aServerData = $_SESSION['server_data'];
            $size = base64_decode($aServerData[7]);
        }
    }
    else
        $size = base64_decode($recorder_size);

    $smarty->assign(array(
            'ENCODING' => ENCODING,
            'MYTV_VER' => MYTV_VER,
            'LANG' => $lang['LANG'],
            'TITLE' => $lang['TITLE'],
            'SID' => $sid,
            'REC_START_TIME_TITLE' => $lang['REC_START_TIME_TITLE'],
            'REC_END_TIME_TITLE' => $lang['REC_END_TIME_TITLE'],
            'REC_CHANNEL_TITLE' => $lang['REC_CHANNEL_TITLE'],
            'REC_SIZE_TITLE' => $lang['REC_SIZE_TITLE'],
            'MENU_REC_ADD' => $lang['MENU_REC_ADD'],
            'MENU_MAINMENU' => $lang['MENU_MAINMENU'],
            'MENU_REC_REFRESH' => $lang['MENU_REC_REFRESH'],
            'REC_LIST_START_TIME_TITLE' => $lang['REC_LIST_START_TIME_TITLE'],
            'REC_LIST_END_TIME_TITLE' => $lang['REC_LIST_END_TIME_TITLE'],
            'REC_LIST_CHANNEL_TITLE' => $lang['REC_LIST_CHANNEL_TITLE'],
            'REC_LIST_SIZE_TITLE' => $lang['REC_LIST_SIZE_TITLE'],
            'MENU_REC_DELETE' => $lang['MENU_REC_DELETE'],
            'REC_START_TIME' => $start_time,
            'REC_END_TIME' => $end_time,
            'REC_CHANNEL' => $channel,
            'REC_LIST_FILE_NAME' => $lang['REC_LIST_FILE_NAME'],
            'REC_LIST_FILE_SIZE' => $lang['REC_LIST_FILE_SIZE'],
            'MENU_REC_FILE_DELETE' => $lang['MENU_REC_FILE_DELETE'],
            'MENU_REC_FILE_DOWNLOAD' => $lang['MENU_REC_FILE_DOWNLOAD'],
            ));

    $aSize = loadRecorderData($size);
    $smarty->assign('size_data', $aSize);

    $aData = getAllRecList($sid);

    if ($aData !== false && is_array($aData))
        $smarty->assign('data', $aData);
    else
        $smarty->assign('data', array());

    $aFileData = getAllRecFile($sid);

    if ($aFileData !== false && is_array($aFileData))
        $smarty->assign('file_data', $aFileData);
    else
        $smarty->assign('file_data', array());

    if ($msg != '') {
        $smarty->assign(array(
                'ERROR_MESSAGE' => $msg,
                'ERROR_BEGIN' => '',
                'ERROR_END' => '',
                ));
    }
    else {
        $smarty->assign(array(
                'ERROR_MESSAGE' => '',
                'ERROR_BEGIN' => '<!--',
                'ERROR_END' => '-->',
                ));
    }
    $smarty->display('recorder.tpl');
    return;
}

function getAllRecList($sid)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    fputs($fp, "REC_LIST $sid\n");
    $aData = array();
    $row_num = 0;
    while (!feof($fp)) {
        $buf = trim(fgets($fp));
        if ($buf[0] != '+') break;
        list(/* + */, $start_time, $end_time, $channel, $width, $height, $fname) = explode(' ', $buf);
        $row_num++;
        $aData[] = array(
                    'class' => $row_num++ % 2 == 0 ? 'row2' : 'row1',
                    'start_time' => base64_decode($start_time),
                    'end_time' => base64_decode($end_time),
                    'channel' => base64_decode($channel),
                    'size' => base64_decode($width).'x'.base64_decode($height),
                    'delete_id' => 'rec_delete_'.$fname,
                    );
    }
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $aData;
}

function getAllRecFile($sid)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    fputs($fp, "REC_LIST_FILE $sid\n");
    $aData = array();
    $row_num = 0;
    while (!feof($fp)) {
        $buf = trim(fgets($fp));
        if ($buf[0] != '+') break;
        list(/* + */, $file, $size) = explode(' ', $buf);
        $row_num++;
        $filename = basename(base64_decode($file));
        $aData[] = array(
                    'class' => $row_num++ % 2 == 0 ? 'row2' : 'row1',
                    'fname' => $filename,
                    'fileid' => md5(base64_decode($file)),
                    'size' => number_format(base64_decode($size)),
                    'delete_id' => 'rec_file_delete_'.base64_encode($filename),
                    );
    }
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $aData;
}

?>
